# Made by Alexsandr Tortsev
import pygame
from pygame.locals import *
import sys
import threading
global R
R = 15
pygame.init()
screen = pygame.display.set_mode((1000, 1000))
eve = threading.Event()
font = pygame.font.Font(None, 16)
class Non_Select(Exception): pass

class Draw_Thread(threading.Thread):
    def __init__(self, system):
        threading.Thread.__init__(self)
        self.daemon = True
        self.system = system
    def run(self):
        connect = self.system.connect
        while True:
            eve.wait()
            self.system.screen.fill((255, 255, 255))
            #token = self.system.token
            #if token:
            started = self.system.coord_s
            finished = self.system.coord_f
            connect = self.system.connect
            if connect:
                pygame.draw.aaline(self.system.screen, (0, 0, 0), started, finished)
            for knot in self.system.knots:
                knot.draw_con(self.system.screen)
            for knot in self.system.knots:
                knot.draw_knot(self.system.screen)
            pygame.display.flip()
            #self.system.token = False
            eve.clear()

class Knot():
    def __init__(self, coord, name):
        self.color = (0,0,0)
        self.main_color = (0,0,0)
        self.connections = []
        self.name = name
        self.rect = pygame.Rect((0,0),(2*R, 2*R))
        self.im = font.render(str(self.name), True, (255,255,0))
        self.rect.center = coord
    def draw_con(self, screen):
        for con in self.connections:
            if self.color == con.color:
                color = self.color
            else:
                color = (0, 0, 0)
            pygame.draw.aaline(screen, color, self.rect.center, con.rect.center, 0)
    def draw_knot(self, screen):
        self.rect = pygame.draw.circle(screen, self.color, self.rect.center, R, 0)
        coord = (self.rect.center[0] - self.im.get_width()//2, self.rect.center[1] - self.im.get_height()//2)
        screen.blit(self.im, coord)
    def self_remove(self, gr):
        for con in self.connections:
            con.connections.remove(self)
        gr.knots.remove(self)
    def connect(self, knot):
        self.connections.append(knot)
        knot.connections.append(self)
        
        
class GR():
    def __init__(self, screen, target):
        self.knots = []
        self.store = []
        self.screen = screen
        self.target = target
        self.connect = False
        self.connected = None
        self.coord_f = None
        self.coord_s = None
        #self.token = False
        
    def run(self):
        cur_name = 0
        drag = False
        draged = None
        breaker = False
        screen = self.screen
        selected = None
        select = False
        stoped = False
        drawer = Draw_Thread(self)
        drawer.start()
        while not breaker:
            for event in pygame.event.get():
                if self.connect:
                    self.coord_f = pygame.mouse.get_pos()
                    #self.token = True
                
                if event.type == QUIT:
                    sys.exit()

                if event.type == MOUSEMOTION:
                    if stoped:
                        stoped = False
                    elif drag and i_can(event.pos):
                        if i_free(draged, event.rel, self.knots):
                            draged.rect.move_ip(event.rel)
                        pygame.mouse.set_pos(draged.rect.center)
                        stoped = True
                    try:
                        for knot in self.knots:
                            if knot.rect.collidepoint(event.pos):
                                selected = knot
                                select = True
                                selected.color = (0, 255, 0)
                                raise Non_Select()
                        if select:
                            selected.color = selected.main_color
                            selected = None
                            select = False
                    except Non_Select:
                        pass
                    
                elif event.type == MOUSEBUTTONDOWN:
                    if event.button == 1:
                        if select:
                            drag = True
                            draged = selected
                        if not drag and i_can(event.pos):
                            self.knots.append(Knot(event.pos, cur_name))
                            cur_name += 1
                    elif event.button == 3:
                        if drag:
                            drag = False
                            draged.self_remove(self)
                            cur_name -= 1
                            draged = None
                            self.connect = False
                            self.connected = None
                            
                        else:
                            if select:
                                self.coord_s = event.pos
                                self.coord_f = event.pos
                                self.connect = True
                                self.connected = selected
                                
                elif event.type == KEYDOWN:
                    if event.key == K_r:
                        self.target(self)
                    elif event.key == K_c:
                        while len(self.knots) > 0:
                            self.knots[0].self_remove(self)
                        self.store = []
                        cur_name = 0
                        
                            
                elif event.type == MOUSEBUTTONUP:
                    if event.button == 1 and drag:
                        drag = False
                        draged = None
                    elif event.button == 3 and self.connect and select:
                        if selected not in self.connected.connections:
                            selected.connect(self.connected)
                        self.connect = False
                        self.connected = None
                        #self.token = False
                        self.coord_s = None
                        self.coord_f = None
                    else:
                        self.connect = False
                        self.connected = None
                        #self.token = False
                        self.coord_s = None
                        self.coord_f = None
                eve.set()

        

def i_can(pos):
    return (R < pos[0] < 1000 - R) and (R < pos[1] < 1000 - R)

def i_free(knot, strafe, kset):
    for v in kset:
        if v != knot and v.rect.colliderect(knot.rect.move(strafe)):
            return False
    return True

def psev(syst):
    pass

def print_k(knots):
    a = ""
    for knot in knots:
        a += str(knot.name) + " "
    print(a)
    
machine = GR(screen, psev)
machine.run()
